<?php
/*
Copyright: © 2009 WebSharks, Inc. ( coded in the USA )
<mailto:support@websharks-inc.com> <http://www.websharks-inc.com/>

Released under the terms of the GNU General Public License.
You should have received a copy of the GNU General Public License,
along with this software. In the main directory, see: /licensing/
If not, see: <http://www.gnu.org/licenses/>.
*/
/*
Direct access denial.
*/
if (realpath (__FILE__) === realpath ($_SERVER["SCRIPT_FILENAME"]))
	exit ("Do not access this file directly.");
/*
Function for saving all options from any page.
*/
if (!function_exists ("ws_widget__ad_squares_update_all_options"))
	{
		function ws_widget__ad_squares_update_all_options ()
			{
				do_action ("ws_widget__ad_squares_before_update_all_options", get_defined_vars ());
				/**/
				if (($nonce = $_POST["ws_widget__ad_squares_options_save"]) && wp_verify_nonce ($nonce, "ws-widget--ad-squares-options-save"))
					{
						$options = $GLOBALS["WS_WIDGET__"]["ad_squares"]["o"]; /* Get current options. */
						/**/
						foreach ($_POST as $key => $value) /* Go through each post variable and look for ad_squares. */
							{
								if (preg_match ("/^" . preg_quote ("ws_widget__ad_squares", "/") . "/", $key)) /* Look for keys. */
									{
										if ($key === "ws_widget__ad_squares_configured") /* This is a special configuration option. */
											{
												update_option ("ws_widget__ad_squares_configured", trim (stripslashes ($value))); /* Update this option separately. */
												/**/
												$GLOBALS["WS_WIDGET__"]["ad_squares"]["c"]["configured"] = trim (stripslashes ($value)); /* Update configuration on-the-fly. */
											}
										else /* We need to place this option into the array. Here we remove the ws_widget__ad_squares_ portion on the beginning. */
											{
												(is_array ($value)) ? array_shift ($value) : null; /* Arrays should be padded, 1st key is removed. */
												$options[preg_replace ("/^" . preg_quote ("ws_widget__ad_squares_", "/") . "/", "", $key)] = $value;
											}
									}
							}
						/**/
						$options["options_version"] = $GLOBALS["WS_WIDGET__"]["ad_squares"]["o"]["options_version"] + 0.001; /* Increment options version. */
						/**/
						$options = ws_widget__ad_squares_configure_options_and_their_defaults ($options); /* Also updates the global options array. */
						/**/
						eval ('foreach(array_keys(get_defined_vars())as$__v)$__refs[$__v]=&$$__v;');
						do_action ("ws_widget__ad_squares_during_update_all_options", get_defined_vars ());
						unset ($__refs, $__v); /* Unset defined __refs, __v. */
						/**/
						update_option ("ws_widget__ad_squares_options", $options); /* Update options in the database now as well. */
						/**/
						ws_widget__ad_squares_display_admin_notice ('<strong>Options saved.</strong>'); /* Display admin notice. */
					}
				/**/
				do_action ("ws_widget__ad_squares_after_update_all_options", get_defined_vars ());
				/**/
				return;
			}
	}
/*
Add options, details, info, etc.
Attach to: add_action("admin_menu");
*/
if (!function_exists ("ws_widget__ad_squares_add_admin_options"))
	{
		function ws_widget__ad_squares_add_admin_options ()
			{
				do_action ("ws_widget__ad_squares_before_add_admin_options", get_defined_vars ());
				/**/
				if (!$GLOBALS["WS_WIDGET__"]["ad_squares"]["c"]["is_multisite_farm"])
					{
						add_filter ("plugin_action_links", "_ws_widget__ad_squares_add_details_link", 10, 2);
						/**/
						if (apply_filters ("ws_widget__ad_squares_during_add_admin_options_create_menu_items", true, get_defined_vars ()))
							{
								if (apply_filters ("ws_widget__ad_squares_during_add_admin_options_add_info_page", true, get_defined_vars ()))
									add_theme_page ("Ad Squares / Widget Information", "Ad Squares Widget", "edit_plugins", "theme-ws-widget--ad-squares-info", "ws_widget__ad_squares_info_page");
							}
					}
				/**/
				do_action ("ws_widget__ad_squares_after_add_admin_options", get_defined_vars ());
				/**/
				return;
			}
	}
/*
A sort of callback function to add the details link.
*/
if (!function_exists ("_ws_widget__ad_squares_add_details_link"))
	{
		function _ws_widget__ad_squares_add_details_link ($links = array (), $file = "")
			{
				eval ('foreach(array_keys(get_defined_vars())as$__v)$__refs[$__v]=&$$__v;');
				do_action ("_ws_widget__ad_squares_before_add_details_link", get_defined_vars ());
				unset ($__refs, $__v); /* Unset defined __refs, __v. */
				/**/
				if (preg_match ("/" . preg_quote ($file, "/") . "$/", $GLOBALS["WS_WIDGET__"]["ad_squares"]["l"]) && is_array ($links))
					{
						$details = '<a href="admin.php?page=theme-ws-widget--ad-squares-info">Details</a>';
						array_unshift ($links, $details);
						/**/
						eval ('foreach(array_keys(get_defined_vars())as$__v)$__refs[$__v]=&$$__v;');
						do_action ("_ws_widget__ad_squares_during_add_details_link", get_defined_vars ());
						unset ($__refs, $__v); /* Unset defined __refs, __v. */
					}
				/**/
				return apply_filters ("_ws_widget__ad_squares_add_details_link", $links, get_defined_vars ());
			}
	}
/*
Add scripts to admin panels.
Attach to: add_action("admin_print_scripts");
*/
if (!function_exists ("ws_widget__ad_squares_add_admin_scripts"))
	{
		function ws_widget__ad_squares_add_admin_scripts ()
			{
				do_action ("ws_widget__ad_squares_before_add_admin_scripts", get_defined_vars ());
				/**/
				if ($_GET["page"] && preg_match ("/ws-widget--ad-squares-/", $_GET["page"]))
					{
						wp_enqueue_script ("jquery");
						wp_enqueue_script ("thickbox");
						wp_enqueue_script ("media-upload");
						wp_enqueue_script ("ws-widget--ad-squares-menu-pages", get_bloginfo ("url") . "/?ws_widget__ad_squares_menu_pages_js=1", array ("jquery", "thickbox", "media-upload"), $GLOBALS["WS_WIDGET__"]["ad_squares"]["o"]["options_version"] . $GLOBALS["WS_WIDGET__"]["ad_squares"]["c"]["filemtime"]);
						/**/
						do_action ("ws_widget__ad_squares_during_add_admin_scripts", get_defined_vars ());
					}
				/**/
				do_action ("ws_widget__ad_squares_after_add_admin_scripts", get_defined_vars ());
				/**/
				return;
			}
	}
/*
Add styles to admin panels.
Attach to: add_action("admin_print_styles");
*/
if (!function_exists ("ws_widget__ad_squares_add_admin_styles"))
	{
		function ws_widget__ad_squares_add_admin_styles ()
			{
				do_action ("ws_widget__ad_squares_before_add_admin_styles", get_defined_vars ());
				/**/
				if ($_GET["page"] && preg_match ("/ws-widget--ad-squares-/", $_GET["page"]))
					{
						wp_enqueue_style ("thickbox");
						wp_enqueue_style ("ws-widget--ad-squares-menu-pages", get_bloginfo ("url") . "/?ws_widget__ad_squares_menu_pages_css=1", array ("thickbox"), $GLOBALS["WS_WIDGET__"]["ad_squares"]["o"]["options_version"] . $GLOBALS["WS_WIDGET__"]["ad_squares"]["c"]["filemtime"], "all");
						/**/
						do_action ("ws_widget__ad_squares_during_add_admin_styles", get_defined_vars ());
					}
				/**/
				do_action ("ws_widget__ad_squares_after_add_admin_styles", get_defined_vars ());
				/**/
				return;
			}
	}
/*
Function that outputs the js for menu pages.
Attach to: add_action("init");
*/
if (!function_exists ("ws_widget__ad_squares_menu_pages_js"))
	{
		function ws_widget__ad_squares_menu_pages_js ()
			{
				do_action ("ws_widget__ad_squares_before_menu_pages_js", get_defined_vars ());
				/**/
				if ($_GET["ws_widget__ad_squares_menu_pages_js"] && is_user_logged_in () && current_user_can ("edit_plugins"))
					{
						header ("Content-Type: text/javascript; charset=utf-8");
						header ("Expires: " . gmdate ("D, d M Y H:i:s", strtotime ("-1 week")) . " GMT");
						header ("Last-Modified: " . gmdate ("D, d M Y H:i:s") . " GMT");
						header ("Cache-Control: no-cache, must-revalidate, max-age=0");
						header ("Pragma: no-cache");
						/**/
						$u = $GLOBALS["WS_WIDGET__"]["ad_squares"]["c"]["dir_url"];
						$i = $GLOBALS["WS_WIDGET__"]["ad_squares"]["c"]["dir_url"] . "/images";
						/**/
						include_once dirname (dirname (__FILE__)) . "/menu-pages/menu-pages.js";
						@include_once dirname (dirname (__FILE__)) . "/menu-pages/menu-pages-s.js";
						/**/
						do_action ("ws_widget__ad_squares_during_menu_pages_js", get_defined_vars ());
						/**/
						exit ();
					}
				/**/
				do_action ("ws_widget__ad_squares_after_menu_pages_js", get_defined_vars ());
			}
	}
/*
Function that outputs the css for menu pages.
Attach to: add_action("init");
*/
if (!function_exists ("ws_widget__ad_squares_menu_pages_css"))
	{
		function ws_widget__ad_squares_menu_pages_css ()
			{
				do_action ("ws_widget__ad_squares_before_menu_pages_css", get_defined_vars ());
				/**/
				if ($_GET["ws_widget__ad_squares_menu_pages_css"] && is_user_logged_in () && current_user_can ("edit_plugins"))
					{
						header ("Content-Type: text/css; charset=utf-8");
						header ("Expires: " . gmdate ("D, d M Y H:i:s", strtotime ("-1 week")) . " GMT");
						header ("Last-Modified: " . gmdate ("D, d M Y H:i:s") . " GMT");
						header ("Cache-Control: no-cache, must-revalidate, max-age=0");
						header ("Pragma: no-cache");
						/**/
						$u = $GLOBALS["WS_WIDGET__"]["ad_squares"]["c"]["dir_url"];
						$i = $GLOBALS["WS_WIDGET__"]["ad_squares"]["c"]["dir_url"] . "/images";
						/**/
						include_once dirname (dirname (__FILE__)) . "/menu-pages/menu-pages.css";
						@include_once dirname (dirname (__FILE__)) . "/menu-pages/menu-pages-s.css";
						/**/
						do_action ("ws_widget__ad_squares_during_menu_pages_css", get_defined_vars ());
						/**/
						exit ();
					}
				/**/
				do_action ("ws_widget__ad_squares_after_menu_pages_css", get_defined_vars ());
			}
	}
/*
Function for building the info page.
*/
if (!function_exists ("ws_widget__ad_squares_info_page"))
	{
		function ws_widget__ad_squares_info_page ()
			{
				do_action ("ws_widget__ad_squares_before_info_page", get_defined_vars ());
				/**/
				include_once dirname (dirname (__FILE__)) . "/menu-pages/info.inc.php";
				/**/
				do_action ("ws_widget__ad_squares_after_info_page", get_defined_vars ());
				/**/
				return;
			}
	}
?>