<?php
/*
Plugin Name: Favourite Bible Verses
Version: 0.8
Plugin URI: http://www.doss-about.co.uk/blog/?p=147
Description: Add your favourite verses from the Bible to be displayed where you like on your blog.
Author: Dan Hadland
Author URI: http://doss-about.co.uk
*/

/*  Copyright 2007  DAN HADLAND  (email : DANHADLAND@GMAIL.COM)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

function fbv_creation() {
	
	global $wpdb;

	$table_name = $wpdb->prefix."fbv";

	if($wpdb->get_var("SHOW TABLES LIKE '$table_name'") != $table_name) { 
		
		$sql = "CREATE TABLE $table_name (
				fbv_id int NOT NULL PRIMARY KEY AUTO_INCREMENT,
				fbv_verse text,
				fbv_ref varchar (50)
				);";

		require_once(ABSPATH."wp-admin/upgrade-functions.php");
		dbDelta($sql);

		$john = "INSERT INTO {$wpdb->prefix}fbv VALUES ( 'NULL', 'For God so loved the world that he gave his one and only Son, that whoever believes in Him shall not perish but have eternal life.', 'John 3:16')";

		$wpdb->query($john);

	}

}

function fbv_menu() {

	add_management_page("Favourite Bible Verse Plugin", "Bible Verses", 8, __FILE__, "fbv_manage");

}

function fbv_manage() {

	global $wpdb;

	if ( $_GET['delete'] && is_numeric( $_GET['delete'] ) ) {
	
		if ( !$_GET['confirm'] ) {
		
			?>
			
			<div class="wrap">
			
			<h2 style="color: #f00">Bible Verse Managment - Delete</h2>
			
			<p>Are you sure you want to delete this entry?</p>
			
			<p><a href="edit.php?page=bibleverse.php&delete=<?php echo $_GET['delete']; ?>&confirm=true">Yes</a> | <a href="edit.php?page=bibleverse.php">No</a></p>
			
			</div>
			
			<?php		
		
		} else {
		
			$wpdb->query( "DELETE FROM " . $wpdb->prefix . "fbv WHERE fbv_id=" . $_GET['delete'] );
		
		}
	
	}


	if (isset($_POST['submit_edit'])) {

		$ref = $_POST['ref'];
		$ver = $_POST['ver'];

		if ( !$ref || !$ver ) {
			$eerror = "You must fill in all fields.";
		} else {

			$wpdb->query("UPDATE {$wpdb->prefix}fbv SET fbv_verse='$ver', fbv_ref='$ref' WHERE fbv_id=".$_GET['edit']);
			$dontdisplay = true;

		} 

	}

		
	if (isset($_POST['submit_add'])) {

		$ref = $_POST['ref'];
		$ver = $_POST['ver'];

		if ( !$ref || !$ver ) {
			$error = "You must fill in all fields.";
		} else {

			$wpdb->query("INSERT INTO {$wpdb->prefix}fbv VALUES ( 'NULL', '$ver', '$ref' )");

		} 

	}

	if ( isset($_GET['edit']) && !$dontdisplay ) {

		$row = $wpdb->get_row( "SELECT * FROM {$wpdb->prefix}fbv WHERE fbv_id=".$_GET['edit'] );

		?>

<div class="wrap">

		<h2>Edit Verse</h2>

		<?php if ( $eerror ) { ?>
		<div class='error'><?php echo $eerror; ?></div>
		<?php } ?>

		<form name="editver" id="editver" method="post" action="">

			<table class="editform" width="100%" cellspacing="2" cellpadding="5">
				<tr><th scope="row" valign="top" width="33%"><label for="ref">Reference:</label></th>
				<td width="67%"><input value="<?php echo $row->fbv_ref; ?>" name="ref" id="ref" type="text" size="40" /></td></tr>
				<tr><th scope="row" valign="top" width="33%"><label for="ver">Verse:</label></th>
				<td width="67%"><textarea name="ver" id="ver" cols="40" rows="5"><?php echo $row->fbv_verse; ?></textarea></td></tr>

			</table>
			
			<p class="submit"><input type="submit" name="submit_edit" value="Edit Verse &raquo;" /></p>

		</form>
		
	</div>

		<?php
	}

	?>

	<div class="wrap">

	<h2>Favourite Bible Verse Management (<a href='#add'>add new</a>)</h2>

	<table class="widefat">
	<thead>
	<tr>
	<th scope="col"><div style="text-align">ID</div></th>
	<th scope="col">Reference</th>
	<th scope="col">Verse</th>
	<th scope="col">&nbsp;</th>
	<th scope="col">&nbsp;</th>
	</tr>
	</thead>
	<tbody id="thelist">

	<?php

	$rows = $wpdb->get_results( "SELECT * FROM {$wpdb->prefix}fbv" );

	foreach( $rows as $row ) {

		echo "<tr>";
		echo "<th scope='row'><div style='text-align: center'>" . $row->fbv_id . "</div></th>";
		echo "<td>{$row->fbv_ref}</td>";
		echo "<td>{$row->fbv_verse}</td>";
		echo "<td><a href='edit.php?page=bibleverse.php&edit={$row->fbv_id}' class='edit'>Edit</a></td>";
		echo "<td><a href='edit.php?page=bibleverse.php&delete={$row->fbv_id}' class='delete'>Delete</a></td>";
		echo "</tr>";

	}

	?>

	</tbody>
	</table>

	</div>

	<div class="wrap" id="add">

		<h2>Add New Verse</h2>

		<?php if ( $error ) { ?>
		<div class='error'><?php echo $error; ?></div>
		<?php } ?>

		<form name="addnew" id="addnew" method="post" action="">

			<table class="editform" width="100%" cellspacing="2" cellpadding="5">
				<tr><th scope="row" valign="top" width="33%"><label for="ref">Reference:</label></th>
				<td width="67%"><input value="<?php echo $ref; ?>" name="ref" id="ref" type="text" size="40" /></td></tr>
				<tr><th scope="row" valign="top" width="33%"><label for="ver">Verse:</label></th>
				<td width="67%"><textarea name="ver" id="ver" cols="40" rows="5"><?php echo $ver; ?></textarea></td></tr>

			</table>
			
			<p class="submit"><input type="submit" name="submit_add" value="Add Verse &raquo;" /></p>

		</form>
		

	</div>

	<?php

}

function fbv_get_verse( $show = "random", $part = "verse" ) {

	global $wpdb;
	global $fbv_id;

	if ( $part == "verse" ) {
		$use = "fbv_verse";
	} else {
		$use = "fbv_ref";
	}

	$type = "random";

	if ( $show != "random" ) {
		$type = "verseref";
	}

	if ( is_numeric( $show ) ) {
		$type = "verseid";
	}

	switch ( $type ) {

		case "random":

			if ( isset( $fbv_id ) ) {
				$row = $wpdb->get_row( "SELECT * FROM {$wpdb->prefix}fbv WHERE fbv_id=$fbv_id" );
			} else {
				$row = $wpdb->get_row( "SELECT * FROM {$wpdb->prefix}fbv ORDER BY RAND() LIMIT 1") ;
			}
			echo $row->$use;
			$fbv_id = $row->fbv_id;

			break;

		case "verseref":

			$row = $wpdb->get_row( "SELECT * FROM {$wpdb->prefix}fbv WHERE fbv_ref LIKE '$show'" );
			echo $row->$use;

			break;

		case "verseid":

			$row = $wpdb->get_row( "SELECT * FROM {$wpdb->prefix}fbv WHERE fbv_id=$show" );
			echo $row->$use;

		break;

	}

}

add_action("activate_bibleverse.php", "fbv_creation");
add_action("admin_menu", "fbv_menu");
?>